

#include <Servo.h> 
 
Servo myservo1;    //max 8 serw
Servo myservo2;
Servo myservo3;
int pos = 0;    
int licz = 0;
int czas = 0;     //czas spowolnienia serwa w ms
boolean wlaczony1 = false;
boolean wlaczony2 = false;
boolean wlaczony3 = false;
boolean wlaczony4 = false;
boolean w_gore = false;
boolean w_dol = false;


#define THROTTLE_SIGNAL_IN 0 // INTERRUPT 0 = DIGITAL PIN 2 - use the interrupt number in attachInterrupt
#define THROTTLE_SIGNAL_IN_PIN 2 // INTERRUPT 0 = DIGITAL PIN 2 - use the PIN number in digitalRead

#define NEUTRAL_THROTTLE 1500 // this is the duration in microseconds of neutral throttle on an electric RC Car

volatile int nThrottleIn = NEUTRAL_THROTTLE; // volatile, we set this in the Interrupt and read it in loop so it must be declared volatile
volatile unsigned long ulStartPeriod = 0; // set in the interrupt
volatile boolean bNewThrottleSignal = false; // set in the interrupt and read in the loop
// we could use nThrottleIn = 0 in loop instead of a separate variable, but using bNewThrottleSignal to indicate we have a new signal 
// is clearer for this first example

void setup()
{
  // tell the Arduino we want the function calcInput to be called whenever INT0 (digital pin 2) changes from HIGH to LOW or LOW to HIGH
  // catching these changes will allow us to calculate how long the input pulse is
  attachInterrupt(THROTTLE_SIGNAL_IN,calcInput,CHANGE);
//=======================================================================servo start
  myservo1.attach(9);  // attaches the servo on pin 9 to the servo object 
  myservo2.attach(6);
  myservo3.attach(5);
//=======================================================================servo stop 
  Serial.begin(9600); 
  myservo1.write(pos=0);
  myservo2.write(pos=0);
  myservo3.write(pos=0);
  
}

void loop()
{
 // if a new throttle signal has been measured, lets print the value to serial, if not our code could carry on with some other processing
 if(bNewThrottleSignal)
 {

   Serial.println(nThrottleIn);  
  //====================================================================================================
  if (nThrottleIn > 1550 && wlaczony1 == false){
    for(pos = 0; pos < 180; pos += 1)  
  {                                  
    myservo1.write(pos);             
    delay(czas);                     
  } 
    w_gore = true;
    w_dol = false;
    wlaczony1 = true;
  }
  //==================================================================================================== 
  if (nThrottleIn < 1150 && w_gore == true && wlaczony1 == true && wlaczony2 == false){
  for(pos = 0; pos < 180; pos += 1)  // goes from 0 degrees to 180 degrees 
  {                                  // in steps of 1 degree 
    myservo2.write(pos);              // tell servo to go to position in variable 'pos' 
    delay(czas);                       // waits 15ms for the servo to reach the position 
  } 

    w_gore = false;
    w_dol = true;
    wlaczony2 = true;
  }
  //====================================================================================================
  if (nThrottleIn > 1550 && w_gore == false && wlaczony2 == true && wlaczony3 == false){
    for(pos = 0; pos < 180; pos += 1)  // goes from 0 degrees to 180 degrees 
  {                                  // in steps of 1 degree 
    myservo3.write(pos);              // tell servo to go to position in variable 'pos' 
    delay(czas);                       // waits 15ms for the servo to reach the position 
  } 

    w_gore = true;
    w_dol = false;
    wlaczony3 = true;
  }
 //=====================================================================================================
  if (nThrottleIn < 1150 && w_gore == true && wlaczony3 == true){
    for(pos = 180; pos>=1; pos -= 1)  // goes from 0 degrees to 180 degrees 
  {                                  // in steps of 1 degree 
    myservo1.write(pos);              // tell servo to go to position in variable 'pos' 
    myservo2.write(pos);              // tell servo to go to position in variable 'pos' 
    myservo3.write(pos);              // tell servo to go to position in variable 'pos' 
    delay(czas);                       // waits 15ms for the servo to reach the position 
  } 

    w_gore = false;
    w_dol = true;
    wlaczony1 = false;
    wlaczony2 = false;
    wlaczony3 = false;
  }
  



}

  
   // set this back to false when we have finished
   // with nThrottleIn, while true, calcInput will not update
   // nThrottleIn
   bNewThrottleSignal = false;
   
 }

 // other processing ... 


void calcInput()
{
  // if the pin is high, its the start of an interrupt
  if(digitalRead(THROTTLE_SIGNAL_IN_PIN) == HIGH)
  { 
    // get the time using micros - when our code gets really busy this will become inaccurate, but for the current application its 
    // easy to understand and works very well
    ulStartPeriod = micros();
  }
  else
  {
    // if the pin is low, its the falling edge of the pulse so now we can calculate the pulse duration by subtracting the 
    // start time ulStartPeriod from the current time returned by micros()
    if(ulStartPeriod && (bNewThrottleSignal == false))
    {
      nThrottleIn = (int)(micros() - ulStartPeriod);
      ulStartPeriod = 0;

      // tell loop we have a new signal on the throttle channel
      // we will not update nThrottleIn until loop sets
      // bNewThrottleSignal back to false
      bNewThrottleSignal = true;
    }
  }
}


